! @(#)verify12.prg	15.1.1.1 (ESO-DMD) 03/02/01 16:40:13 
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!  MIDAS procedure verify12.prg  to verify MIDAS commands
!  K. Banse     010221
!
!  use as @@ verify12 ffffffffff             with f = 1 or 0 (on/off)
!
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 1111111111 n "Enter control flags for entries: "
!
define/local loop/i/1/1 0
define/local rval/r/1/1 0. ? +lower
define/local ival/i/1/5 0 all +lower
define/local seconds/i/1/2 0,0 ? +lower
define/local rcorr/r/1/20 0. all +lower
define/local icorr/i/1/20 0 all +lower
define/local errsum/i/1/1 0 ? +lower
define/local ccc/c/1/10 0000000000
define/local secs/i/1/2 0,0 ? +lower
define/local myvals/i/1/2 0,0 ? +lower
!
delete/temp                             !get rid of old temporary files
! 
write/key sizez/i/1/5 600,600,0,0,0
write/key dispyes/i/1/2 0,0
write/key stop/i/1/1 0
!
write/out +------------------------------------------+
write/out Start of procedure verify12.prg
write/out +------------------------------------------+
!
seconds(1) = m$secs()
write/key ccc {p1}
set/format i1
do loop = 1 2
   if ccc({loop}:{loop}) .eq. "1" @@ verify12,000{loop}
   if errsum .gt. 0 then
      write/out "We got problems with entry 000{loop} in verify12.prg!"
      stop = 1
      return
   endif
enddo
seconds(2) = m$secs()
ival = seconds(2)-seconds(1)
!
write/out +------------------------------------------+
write/out procedure verify12.prg:
write/out Total time elapsed = {ival} seconds.
write/out All tests o.k. - you deserve a coffee now...
write/out +------------------------------------------+
!
!  here the different sub-procedures
!
entry 0001
!
write/out test of CREATE/DISPLAY + CREATE/GRAPHICS
write/out "----------------------------------------"
!
create/display 7 512,512,616,300
create/gra 3 600,400,0,380
dispyes(1) = 1                          !mark that we have display + graphic
dispyes(2) = 1
display/lut off
load/lut smooth
!
entry 0002
!
write/out  test of VIMOS data files
write/out "-------------------------"
!
delete/temp
define/param p1 vimos.fits c "Enter name of FITS file (with type):"
! 
-copy MID_TEST:{p1} {p1}
set/format i1
!
write/out > get an overview of FITS file 
write/out > {p1}:
! 
info/frame {p1} ext
! 
set/midas dscalloc=0,0
secs(1) = m$secs()
display/long
read/descr {p1} 
secs(2) = m$secs()
myvals(1) = secs(2)-secs(1)
!
write/out > with the default settings for the descr. directory
write/out > READ/DESCR {p1} took {myvals(1)} seconds
!
write/out > 
write/out > extension[1] of FITS file {p1} has more than 3000 descriptors
outputi(2) = 3300
outputi(3) = 6000
set/midas dscalloc={outputi(2)},{outputi(3)}
write/out > so let's already allocate space for a big descr. directory
write/out > SET/MIDAS dscalloc={outputi(2)},{outputi(3)}
secs(1) = m$secs()
display/long
read/descr {p1} 
secs(2) = m$secs()
myvals(2) = secs(2)-secs(1)
write/out > now READ/DESCR {p1} took {myvals(2)} seconds
outputr = (myvals(1)-myvals(2))/myvals(1)
outputi = outputr*100
write/out > which is a {outputi} % saving
! 
write/out > 
write/out > Convert all extensions of {p1} to internal Midas format
indisk/mfits vimos.fits mvim
!
if dispyes(2) .eq. 1 then
   load/image mvim0001 scale=-4 cuts=185,900
endif
! 
write/out > 
write/out > STATISTICS/IMAGE mvim0001
statistics/image mvim0001
write/key rcorr 185.0,9817.0,229.723,285.404 
write/key rcorr/r/5/3 20.2331,461.563,1.15466355E+09
write/key icorr  5026320,36,167,1246,1469
@@ kcompare rcorr outputr 1,4 0.01
@@ kcompare rcorr outputr 5,6 0.3
@@ kcompare rcorr outputr 7,7 0.5
@@ kcompare icorr outputi 1,5
write/out > 
write/out > STATISTICS/IMAGE mvim0002
statistics/image mvim0002
write/key rcorr  200.0,13458.0,303.924,119.379
write/key rcorr/r/5/3 21.5018,1524.79,1.52761946E+09
write/key icorr  5026320,9,1794,1269,802  
@@ kcompare rcorr outputr 1,4 0.01
@@ kcompare rcorr outputr 5,6 0.3
@@ kcompare rcorr outputr 7,7 0.5
@@ kcompare icorr outputi 1,5
! 
write/out >  
write/out > one can access FITS extensions directly in a Midas command, e.g.:
write/out > STATISTICS/IMAGE {p1}[2]
write/out > should be the same as:
write/out > STATISTICS/IMAGE mvim0002
statistics/image {p1}[2]
write/key rcorr  200.0,13458.0,303.924,119.379
write/key rcorr/r/5/3 21.5018,1524.79,1.52761946E+09
write/key icorr  5026320,9,1794,1269,802  
@@ kcompare rcorr outputr 1,4 0.01
@@ kcompare rcorr outputr 5,6 0.3
@@ kcompare rcorr outputr 7,7 0.5
@@ kcompare icorr outputi 1,5
! 
write/out >  
write/out > now some number crunching: "COMPUTE/IMAGE vv = mvim0001 + 123.456"
secs(1) = m$secs()
compute/image vv = mvim0001 + 123.456
secs(2) = m$secs()
myvals(1) = secs(2)-secs(1)
write/out > COMPUTE/IMAGE took {myvals(1)} seconds
write/out > "but most of the time was spent copying the more than" -
            3000 descriptors...
write/out > let's turn off the descriptor copying, via: SET/MIDAS dsccopy=no
write/out > COMPUTE/IMAGE vv = mvim0001 + 123.456
set/midas dsccopy=no
secs(1) = m$secs()
compute/image vv = mvim0001 + 123.456
secs(2) = m$secs()
myvals(2) = secs(2)-secs(1)
write/out > now the COMPUTE/IMAGE took {myvals(2)} seconds
set/midas dsccopy=yes			!needed for other verifications
! 
write/out >  
write/out > "now rebuild the Vimos FITS file and add image `vv.bdf' as" -
            third extension 
write/out > OUTDISK/SFITS mvim0000.bdf,mvim0001.bdf,mvim0002.bdf,vv.bdf newVIMOS.fits
OUTDISK/SFITS mvim0000.bdf,mvim0001.bdf,mvim0002.bdf,vv.bdf newVIMOS.fits
! 
set/midas dscalloc=0,0
!
entry 0004
!
write/out  test of CONVERT/DESCR_MATRIX
write/out "-----------------------------"
! 
set/format i1
show/descr mvim0001 >Null
myvals(1) = outputi				!save total
! 
write/out >
write/out > get rid of that ESO.INS.SLIT descriptor matrix via
write/out > -
CONVERT/DESCR_MATRIX mvim0001 slittab ds-t eso.ins.slit type,id,x,y,dimx,dimy 1
CONVERT/DESCR mvim0001 slittab ds-t eso.ins.slit type,id,x,y,dimx,dimy 1
! 
write/out > now, let's time again the COMPUTE statement
secs(1) = m$secs()
compute/image vv = mvim0001 + 123.456
secs(2) = m$secs()
myvals(2) = secs(2)-secs(1)
write/out > COMPUTE/IMAGE took {myvals(2)} seconds
! 
write/out > CONVERT/DESCR mvim0001 slittab t-ds 
CONVERT/DESCR mvim0001 slittab t-ds 
show/descr mvim0001 >Null
if outputi .ne. myvals(1) then
   write/out descr total was {myvals(1)}, is now {outputi}
endif
! 
return
delete/temp
if aux_mode(1) .eq. 1 then
   -delete mvim0*.bdf.*
   -delete vv.bdf.*
   -delete vimos.fits.*
   -delete newVIMOS.fits.*
   -delete slittab.tbl.*
else
   -delete mvim0*.bdf
   -delete vv.bdf
   -delete vimos.fits
   -delete newVIMOS.fits
   -delete slittab.tbl
endif

